--
-- Drive analoge script
-- author: Patar
-- date: 01.11.2014
--
-- Update V2
-- author: Patar
-- date: 02.11.2014

steerable_update = Steerable.update;

DrivingAnalogeFunction = function(self, dt)
	--print("funktion lauft");
	if self.motor ~= nil then
		if self:getIsActiveForSound() then
			local input = math.abs(self.axisForward) --math.abs(-InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE));
			if self.movingDirection == 1 then
				if input > 0 then
					--print("set Limit to "..tostring(self.motor.maxForwardSpeed*3.6*input));
					local wantedSpeed = self.motor.maxForwardSpeed*3.6*input;
					if self.speedLimit > wantedSpeed then
						if self.lastSpeedReal*3600 < self.speedLimit then
							self.speedLimit = math.max(wantedSpeed,self.lastSpeedReal*3600-2);
						end;
						self.speedLimit = self.speedLimit-0.14;
					elseif self.speedLimit < wantedSpeed then
						self.speedLimit = math.min(wantedSpeed, self.lastSpeedReal*3600+2);
					end;
					self.checkSpeedLimit = true;
					self.motor.checkSpeedLimit = true;
				else
					--print("set Limit to "..tostring(self.motor.maxForwardSpeed*3.6*input));
					self.motor.speedLimit = self.motor.maxForwardSpeed*3.6 --tonumber('inf');
					self.speedLimit = self.motor.maxForwardSpeed*3.6 --tonumber('inf');
					self.checkSpeedLimit = false;
					self.motor.checkSpeedLimit = false;
				end;
			else
				if input > 0 then
					--print("set Limit to "..tostring(self.motor.maxForwardSpeed*3.6*input));
					local wantedSpeed = self.motor.maxBackwardSpeed*3.6*input;
					if self.speedLimit > wantedSpeed then
						if math.abs(self.lastSpeedReal*3600) < self.speedLimit then
							self.speedLimit = math.max(wantedSpeed,math.abs(self.lastSpeedReal*3600)-2);
						end;
						self.speedLimit = self.speedLimit-0.14;
					elseif self.speedLimit < wantedSpeed then
						self.speedLimit = math.min(wantedSpeed, math.abs(self.lastSpeedReal*3600)+2);
					end;
					self.checkSpeedLimit = true;
					self.motor.checkSpeedLimit = true;
				else
					--print("set Limit to "..tostring(self.motor.maxForwardSpeed*3.6*input));
					self.motor.speedLimit = self.motor.maxForwardSpeed*3.6 --tonumber('inf');
					self.speedLimit = self.motor.maxForwardSpeed*3.6 --tonumber('inf');
					self.checkSpeedLimit = false;
					self.motor.checkSpeedLimit = false;
				end;
			end;
			--renderText(0.84, 0.58, 0.03, tostring(self.speedLimit));
			--renderText(0.84, 0.54, 0.03, tostring(-self.axisForward));
		end;
	end;
end;

Steerable.update = function(self, dt)
	steerable_update(self, dt);
	DrivingAnalogeFunction(self, dt);
end;